package de.erethon;

import io.papermc.paper.util.MCUtil;
import net.minecraft.network.Connection;
import net.minecraft.network.PacketListener;
import net.minecraft.network.protocol.Packet;
import net.minecraft.server.MinecraftServer;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;
import org.jetbrains.annotations.NotNull;

public class PacketReceiveEvent extends Event {

    private static final HandlerList handlers = new HandlerList();

    private Packet<?> packet;
    private final Connection connection;
    private final PacketListener listener;

    public PacketReceiveEvent(Packet<?> packet, Connection connection, PacketListener listener) {
        super(!MCUtil.isMainThread());
        this.packet = packet;
        this.connection = connection;
        this.listener = listener;
    }

    public Packet<?> getPacket() {
        return packet;
    }

    public void setPacket(Packet<?> packet) {
        this.packet = packet;
    }

    public Connection getConnection() {
        return connection;
    }

    public PacketListener getListener() {
        return listener;
    }

    @Override
    public @NotNull HandlerList getHandlers() {
        return handlers;
    }

    @NotNull
    public static HandlerList getHandlerList() {
        return handlers;
    }
}
