package de.erethon.hephaestus.events;

import net.minecraft.core.BlockPos;
import net.minecraft.core.Holder;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.Mob;
import net.minecraft.world.entity.SpawnGroupData;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.level.biome.Biome;
import net.minecraft.world.level.biome.MobSpawnSettings;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public class MobSpawnEntityCreateEvent extends Event {
    private static final HandlerList handlers = new HandlerList();

    public ServerLevel world;
    public MobSpawnSettings.SpawnerData spawnerData;
    public Mob mob;
    public BlockPos.MutableBlockPos pos;
    public Player nearestPlayer;
    public SpawnGroupData data;

    public MobSpawnEntityCreateEvent(Mob mob, ServerLevel world, MobSpawnSettings.SpawnerData spawnerData, BlockPos.MutableBlockPos pos, Player player, @Nullable SpawnGroupData data) {
        this.mob = mob;
        this.world = world;
        this.spawnerData = spawnerData;
        this.pos = pos;
        this.nearestPlayer = player;
        this.data = data;
    }


    @NotNull
    @Override
    public HandlerList getHandlers() {
        return handlers;
    }

    public static HandlerList getHandlerList() {
        return handlers;
    }
}
