package de.erethon.hephaestus.events;

import net.minecraft.core.BlockPos;
import net.minecraft.core.Holder;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.util.RandomSource;
import net.minecraft.util.random.WeightedRandomList;
import net.minecraft.world.entity.MobCategory;
import net.minecraft.world.level.StructureManager;
import net.minecraft.world.level.biome.Biome;
import net.minecraft.world.level.biome.MobSpawnSettings;
import net.minecraft.world.level.chunk.ChunkGenerator;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;
import org.jetbrains.annotations.NotNull;

import javax.annotation.Nullable;
import java.util.Optional;

public class MobSpawnSettingsEvent extends Event {

    private static final HandlerList handlers = new HandlerList();

    public Holder<Biome> biomeHolder;
    public WeightedRandomList<MobSpawnSettings.SpawnerData> spawnerData;
    public ServerLevel world;
    public StructureManager structureAccessor;
    public ChunkGenerator chunkGenerator;
    public MobCategory spawnGroup;
    public RandomSource random;
    public BlockPos pos;

    public MobSpawnSettingsEvent(ServerLevel world, StructureManager structureAccessor, ChunkGenerator chunkGenerator, MobCategory spawnGroup, BlockPos pos, @Nullable Holder<Biome> biomeEntry) {
        this.biomeHolder = biomeEntry;
        this.world = world;
        this.structureAccessor = structureAccessor;
        this.chunkGenerator = chunkGenerator;
        this.spawnGroup = spawnGroup;
        this.pos = pos;
        this.spawnerData = null;
    }

    @NotNull
    @Override
    public HandlerList getHandlers() {
        return handlers;
    }

    public static HandlerList getHandlerList() {
        return handlers;
    }
}
