package de.erethon.papyrus;

import net.minecraft.core.NonNullList;
import net.minecraft.world.item.ItemStack;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;
import org.jetbrains.annotations.NotNull;

public class ContainerLoadEvent extends Event {

    private static final HandlerList handlers = new HandlerList();

    private NonNullList<ItemStack> itemStacks;

    /**
     * Note: This event may be triggered async during feature placement.
     * This shouldn't happen on Erethon, but who knows.
     */
    public ContainerLoadEvent(NonNullList<ItemStack> items, boolean async) {
        super(async);
        this.itemStacks = items;
    }

    public NonNullList<ItemStack> getItemStacks() {
        return itemStacks;
    }

    @NotNull
    @Override
    public HandlerList getHandlers() {
        return handlers;
    }

    public static HandlerList getHandlerList() {
        return handlers;
    }
}
